Attribute VB_Name = "basAutoIndent"
Public Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long


Public Const EM_LINEINDEX = &HBB
Public Const EM_GETFIRSTVISIBLELINE = &HCE
Public Const EM_GETLINECOUNT = &HBA

Private Const PLUS As Integer = 1
Private Const MINUS As Integer = 0

Dim lines() As String
Dim tabNo As Integer
Dim tmpSS As Integer
Private Const NoIndent As String = "Public Type;Private Type;Private Sub;Public Property;Public Sub;Private Function;Public Function;Function ;Private Enum;Public Enum;Friend Property;Friend Sub;Friend Function;End Sub;End Property;End Type;End Function;End Enum"
Private Const IAfter As String = "If ;For ;Open ;With ;Do;Public Type;Private Type;While ;Select Case;Private Sub;Public Property;Public Sub;Private Function;Public Function;Function ;Private Enum;Public Enum;Friend Property;Friend Sub;Friend Function"
Private Const TrackIt As String = "If ;For ;Open ;With ;Do;While ;Select Case;Next;Close;End With;Loop;End If;Wend;End Select"
Private Const IBefore As String = "Next;Close ;End With;Loop;End If;Wend;End Select;End Sub;End Property;End Type;End Function;End Enum"
Private Const IB_R As String = "For ;Open ;With ;Do;If ;While ;Select Case;;;;;"

Private Const IBoth As String = "Else;Case"


Public Function AutoIndent(rtb As RichTextBox) As Long
    
    Dim X As Long
    Dim i As Integer
    Dim INDT As Boolean
    Dim CI As New Collection
    Dim stmp As String
    Dim Skipped As Boolean
    Dim T As Integer
    Dim IA() As String
    Dim IB() As String
    Dim II() As String
    Dim IR() As String
    Dim NI() As String
    Dim L As Integer
    Dim strt As Long
    Dim fin As Long
    Dim Rebuild As String
    Erase lines
    tabNo = 0
    tmpSS = 0
    Dim CFR As String
    
    tmpSS = rtb.SelStart
    rtb.SelStart = 0
    rtb.SelLength = Len(rtb.Text)
    rtb.SelColor = 0
    rtb.SelStart = 0
    lines = Split(Replace(rtb.Text, vbTab, ""), vbCrLf)
    strt = 0
    fin = UBound(lines)
    
    DoEvents
    T = 0
    IA = Split(LCase(IAfter), ";")
    IB = Split(LCase(IBefore), ";")
    II = Split(LCase(IBoth), ";")
    IR = Split(LCase(IB_R), ";")
    NI = Split(LCase(NoIndent), ";")
    For X = strt To fin
        lines(X) = Trim(LCase(lines(X)))
        'Check for line continue
        If Right(RTrim(lines(X)), 1) = "_" And INDT = False Then
            INDT = True
            L = L + 1
        ElseIf Right(RTrim(lines(X)), 1) = "_" And INDT = True Then
            DoLine X, L
        ElseIf Right(RTrim(lines(X)), 1) <> "_" And INDT = True Then
            INDT = False
            DoLine X, L
            L = L - 1
        End If
        'Add INdent
        For i = 0 To UBound(NI)
            If Left(Trim(lines(X)), Len(NI(i))) = NI(i) Then
                T = 0
                'DoLine x, T
                'GoTo NxtLine
                Exit For
            End If
        Next
        
        For i = 0 To UBound(IA)
            If Left(Trim(lines(X)), Len(IA(i))) = IA(i) Then
                If IA(i) = "Do" Then
                    stmp = Trim(vbCode.lines(X, 1))
                    Skipped = True
                    If Left(stmp, 3) = "Do " Or stmp = "Do" Then Skipped = False
                End If
                If InStr(LCase(TrackIt), IA(i)) Then
                    If IA(i) = "if " Then
                        If Right(RTrim(lines(X)), 4) = "then" Then
                            CI.Add IA(i) & "_" & X & "_" & T
                        ElseIf Right(RTrim(lines(X)), 1) = "_" Then
                            CI.Add IA(i) & "_" & X & "_" & T
                        End If
                    Else
                        CI.Add IA(i) & "_" & X & "_" & T
                    End If
                End If
                If IA(i) = "if " Then
                    If Right(RTrim(lines(X)), 4) = "then" Then
                        DoLine X, T
                        T = T + 1
                    ElseIf Right(RTrim(lines(X)), 1) = "_" Then
                        DoLine X, T
                        T = T + 1
                    Else
                        DoLine X, T
                    End If
                    GoTo NxtLine
                Else
                    DoLine X, T
                    If Not Skipped Then
                        T = T + 1
                    End If
                    GoTo NxtLine
                End If
                
            End If
            
        Next
        'Subtract Indent
        Dim Z As Integer
        Dim tmp() As String
        For i = 0 To UBound(IB)
            If Left(Trim(lines(X)), Len(IB(i))) = IB(i) Then
                If InStr(LCase(TrackIt), IB(i)) Then
                    For Z = CI.Count To 1 Step -1
                        tmp = Split(CI(Z), "_")
                        If tmp(0) = IR(i) Then
                            DoLine X, CInt(tmp(2))
                            CI.Remove Z
                            T = CInt(tmp(2)) 'T - 1
                            Exit For
                        End If
                    Next
                Else
                    T = T - 1
                    If T < 0 Then T = 0
                    'If IB(I) = "End Select" Then T = T - 1
                    DoLine X, T
                End If
                GoTo NxtLine
            End If
        Next
        'Subtract / Then Add
        For i = 0 To UBound(II)
            If Left(Trim(lines(X)), Len(II(i))) = II(i) Then
                For Z = CI.Count To 1 Step -1
                    tmp = Split(CI(Z), "_")
                    If II(i) = "else" Then
                        If tmp(0) = "if " Then
                            DoLine X, CInt(tmp(2))
                            T = CInt(tmp(2)) + 1
                            Exit For
                        End If
                    ElseIf II(i) = "case" Then
                        If tmp(0) = "select case" Then
                            DoLine X, CInt(tmp(2)) + 1
                            T = CInt(tmp(2)) + 2
                            Exit For
                        End If
                    End If
                Next
                GoTo NxtLine
            End If
        Next
        
        DoLine X, T
NxtLine:
        If T < 0 Then T = 0
    Next
    For X = 0 To UBound(lines)
        Rebuild = Rebuild & lines(X) & vbCrLf
    Next
    If frmMain.LoadingIt = True Then
        Do Until Right(Rebuild, 4) <> vbCrLf & vbCrLf
            Rebuild = Left(Rebuild, Len(Rebuild) - 2)
        Loop
    End If
    If frmMain.LoadingIt Then tmpSS = 0
    rtb.Text = RTrim(Rebuild)
    rtb.SelLength = 0
    rtb.SelStart = 0
    rtb.SelStart = tmpSS
    If frmMain.LoadingIt = True Then
        frmMain.rs!Code = rtb.Text
        frmMain.rs.Update
    End If
    
End Function
Private Sub DoLine(X As Long, T As Integer)
    lines(X) = TABS(T) & lines(X)
End Sub
Private Function TABS(tNum As Integer) As String
    If tNum < 0 Then tNum = 0
    TABS = String(tNum, vbTab)
End Function
