VERSION 5.00
Begin VB.Form frmFind 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find Code"
   ClientHeight    =   1395
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   5670
   Icon            =   "frmFind.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1395
   ScaleWidth      =   5670
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdReset 
      Cancel          =   -1  'True
      Caption         =   "Reset Search"
      Height          =   330
      Left            =   4380
      TabIndex        =   7
      Top             =   555
      Visible         =   0   'False
      Width           =   1185
   End
   Begin VB.CheckBox chkCurrentOnly 
      Caption         =   "Current Code Only"
      Enabled         =   0   'False
      Height          =   225
      Left            =   1845
      TabIndex        =   6
      Top             =   780
      Width           =   1695
   End
   Begin VB.CheckBox chkSearchType 
      Caption         =   "Auto Find (Search as you type)"
      Height          =   225
      Left            =   330
      TabIndex        =   5
      Top             =   540
      Width           =   2535
   End
   Begin VB.CommandButton cmdFind 
      Caption         =   "Find"
      Default         =   -1  'True
      Height          =   330
      Left            =   4380
      TabIndex        =   4
      Top             =   135
      Width           =   1185
   End
   Begin VB.CheckBox chkMatchCase 
      Caption         =   "Match Case"
      Enabled         =   0   'False
      Height          =   225
      Left            =   330
      TabIndex        =   3
      Top             =   1020
      Width           =   1530
   End
   Begin VB.CheckBox chkSearchInCode 
      Caption         =   "Search in Code"
      Height          =   225
      Left            =   330
      TabIndex        =   2
      Top             =   780
      Width           =   1440
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   330
      Left            =   4380
      TabIndex        =   1
      Top             =   975
      Width           =   1185
   End
   Begin VB.TextBox txtFind 
      Height          =   285
      Left            =   150
      TabIndex        =   0
      Top             =   150
      Width           =   4155
   End
End
Attribute VB_Name = "frmFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal y As Long, ByVal cx As Long, ByVal cY As Long, ByVal wFlags As Long) As Long

Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
Private Const SWP_NOMOVE = 2
Private Const SWP_NOSIZE = 1
Private Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Dim Skip As Integer
Dim Loading As Boolean
Dim NewF As Boolean


Private Sub chkCurrentOnly_Click()
    If Loading Then Exit Sub
    If chkCurrentOnly.Value = 0 And cmdFind.Enabled = False Then cmdFind.Enabled = True
End Sub

Private Sub chkSearchInCode_Click()
    If Loading Then Exit Sub
    chkMatchCase.Enabled = chkSearchInCode
    chkCurrentOnly.Enabled = chkSearchInCode
    If Trim(frmMain.RTB1.Text) = "" Or chkSearchInCode.Value = 0 Then chkCurrentOnly.Enabled = False
    If chkMatchCase.Enabled = False Then chkMatchCase = 0
    If chkCurrentOnly.Enabled = False Then chkCurrentOnly = 0
    txtFind.SetFocus
    txtFind_Change
End Sub

Private Sub cmdFind_Click()
    If cmdFind.Caption = "Find Next" Then
        NewF = False
        Skip = Skip + 1
        Search
    Else
        Search
        cmdFind.Caption = "Find Next"
    End If
    
End Sub

Private Sub cmdReset_Click()
    cmdFind.Caption = "Find"
    Me.Caption = "Find Code"
    cmdReset.Visible = False
    cmdFind.Enabled = True
    Skip = 0
    NewF = True
End Sub

Private Sub Form_Load()
    frmMain.FindForm = True
    Loading = True
    chkSearchType.Value = GetSetting("CodeBank3", "Options", "SearchType", 0)
    chkSearchInCode.Value = GetSetting("CodeBank3", "Options", "SearchInCode", 0)
    If chkSearchInCode.Value <> 0 Then
        chkMatchCase.Enabled = True
        If Trim(frmMain.RTB1.Text) <> "" Then
            chkCurrentOnly.Enabled = True
            chkCurrentOnly.Value = GetSetting("CodeBank3", "Options", "CurrentOnly", 0)
        End If
        chkMatchCase.Value = GetSetting("CodeBank3", "Options", "MatchCase", 0)
    End If
    Skip = 0
    NewF = True
    Loading = False
End Sub




Private Sub Form_Unload(Cancel As Integer)
    SaveSetting "CodeBank3", "Options", "SearchType", chkSearchType.Value
    SaveSetting "CodeBank3", "Options", "SearchInCode", chkSearchInCode.Value
    SaveSetting "CodeBank3", "Options", "MatchCase", chkMatchCase.Value
    SaveSetting "CodeBank3", "Options", "CurrentOnly", chkCurrentOnly.Value
    frmMain.FindForm = False
End Sub
Private Sub Search()
    Dim mCase As Integer
    Dim CConly As Boolean
    frmMain.CodeChanged = False
    If chkMatchCase <> 0 Then mCase = 0 Else mCase = 1
    If chkCurrentOnly <> 0 Then CConly = True Else CConly = False
    If chkSearchInCode = 1 Then
        frmMain.FindText txtFind, Skip, mCase, NewF, CConly
    Else
        frmMain.FindIt txtFind, Skip
    End If
    frmMain.CodeChanged = False
    txtFind.SetFocus
    If frmMain.RTB1.Text <> "" Then chkCurrentOnly.Enabled = True
End Sub
Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub Form_Paint()
    txtFind.SetFocus
End Sub

Private Sub txtFind_Change()
    If Loading Then Exit Sub
    cmdFind.Caption = "Find"
    cmdReset.Visible = False
    cmdFind.Enabled = True
    Me.Caption = "Find '" & txtFind & "'"
    Skip = 0
    NewF = True
    If txtFind = "" Then frmMain.RTB1.SelLength = 0: Exit Sub
    If chkSearchType = 0 Then Exit Sub
    If chkSearchType <> 0 Then cmdFind.Caption = "Find Next"
    Search
End Sub
